<?php
/**
 *	GeSHi Plugin 0.4+ for MODx
 *	by Luca Allulli, April 2006
 *
 *  Event: OnLoadWebDocument
 *
 *	Based on the GeSHi highlighter at http://qbnz.com/highlighter/
 *
 *	License: GNU GPL
 *
 */
 
//Begin configuration
    global $defaultGeshiLang;
	$defaultGeshiLang="java5";
	
	/*$options['lines'] = isset($lines_to_scroll)? $lines_to_scroll : 20;
	$options['width'] = isset($width)? $width : 600;
	$options['height'] = isset($height)? $height : 300;
	$options['tab_size'] = isset($tab_size)? $tab_size : 4;
	$options['line_numbers'] = isset($line_numbers)? $line_numbers : true;
	$options['no_links'] = isset($disable_keyword_linking)? $disable_keyword_linking : true;
	$options['inline'] = isset($inline)? $inline : false;*/
//End configuration 
 
function replaceCodeBase($lang, $code) {
	global $modx;

    // See if we should force a height
    $num_lines = count(explode("\n", $code));

    // Preprocess source text
    $code = str_replace(array("\\\"", "\\\'"), array ("\"", "\'"), $code);
    $code = preg_replace('/(< \?php)/i', '<?php', $code);
    $code = preg_replace('/(?:^(?:\s*[\r\n])+|\s+$)/', '', $code);

	$path = $modx->config["base_path"].'assets/plugins/geshi/geshi/';
	$geshi = new GeSHi($code, $lang, $path);
    $geshi->enable_line_numbers(GESHI_NO_LINE_NUMBERS, 1);
	$geshi->set_header_type(GESHI_HEADER_DIV);
    $geshi->set_overall_class('codecolorer');
	$geshi->set_tab_width(4);
    $geshi->enable_classes();
    $geshi->set_overall_style('white-space:nowrap');

    $result = $geshi->parse_code();
    if ($geshi->error()) {
      return $geshi->error();
    }

    #if ($options['line_numbers'] && !$options['inline']) {
      $table = '<table cellspacing="0" cellpadding="0"><tbody><tr><td ';
      $table .= 'class="line-numbers"';
      $table .= '><div>';
      for ($i = 0, $count = substr_count($result, '<br />') + 1; $i < $count; $i++) {
        $table .= ($i + $options['first_line']) . '<br />';
      }
      $result = $table . '</div></td><td>' . $result . '</td></tr></tbody></table>';
    #}
    $result = AddContainer($result, $options, $num_lines);

    return $result;
	#return '<table width="100%"><tr><td>'.$geshi->parse_code().'</td></tr></table>';
}

function replaceCode($matches) {
	global $defaultGeshiLang;
	return replaceCodeBase($defaultGeshiLang, $matches[1]);
}

function replaceCodeLang($matches) {
	return replaceCodeBase($matches[1], $matches[2]);
}


$e = &$modx->Event;


switch ($e->name) {
	case "OnLoadWebDocument":

		include_once($modx->config["base_path"].'assets/plugins/geshi/geshi.php');

		$modx->documentObject['content']=preg_replace_callback("#<code>(.*?)</code>#s", "replaceCode", $modx->documentObject['content']);

		$modx->documentObject['content']=preg_replace_callback("#<code lang=\"([^\"]*)\">(.*?)</code>#s", "replaceCodeLang", $modx->documentObject['content']);

		break;
		
	default:	// stop here
		return; 
		break;	
}

  function AddContainer($html, $options, $num_lines) {
    /*if ($options['inline']) {
      $theme = empty($options['inline_theme']) ? 'default' : $options['inline_theme'];
      $result  = '<code class="codecolorer ' . $options['lang'] . ' ' . $theme . '">';
      $result .= '<span class="' . $options['lang'] . '">' . $html . '</span>';
      $result .= '</code>';
    } else {*/
      $theme = empty($options['theme']) ? 'default' : $options['theme'];
      $style = 'style="';
      $style .= 'overflow:auto;white-space:nowrap;';
      /*if (is_feed()) $style .= 'border: 1px solid #9F9F9F;';
      $style .= $GetDimensionRule('width', is_feed() ? $options['rss_width'] : $options['width']);*/
      if($num_lines > $options['lines'] && $options['lines'] > 0) {
        $style .= $GetDimensionRule('height', $options['height']);
      }
      $style .= '"';

      $css_class = 'codecolorer-container ' . $options['lang'] . ' ' . $theme;
      #if ($options['noborder']) $css_class .= ' codecolorer-noborder';
      $result = '<div class="' . $css_class . '" ' . $style . '>' . $html . '</div>';
    #}
    return $result;
  }
  
    function GetDimensionRule($dimension, $value) {
    $rule = '';
    if (!empty($value)) $rule = "$dimension:$value" . (is_numeric($value) ? 'px;' : ';');
    return $rule;
  }